//
// Copyright (C) 2007-2012  Hideaki Takenaka
//
// Flat binary Reader and Writer 2007/02/21
//

import java.lang.Math.*;
import java.io.*;
import java.nio.*;
import java.nio.channels.*;


public class bin{


bin(){

}// super


public void ius2bin(String filename, int X, int Y,int[][] int_num)
{

        int I,J,K,L,M,N;
        int ix,iy;


         System.out.print(filename +"  Writing ...");
                //////// Binary writer ////////
		try {

			DataOutputStream dos = 
			       new DataOutputStream(new BufferedOutputStream(
                                     new FileOutputStream(filename), 20971520));


                        for(I=1;I<=Y;I++)
                        { 
                           for(J=1;J<=X;J++)
                           {

                                dos.writeShort(int_num[I][J]);

                           }// J
                        }// I


			dos.close();
		}
		catch(IOException e)
                {
                  System.err.println(filename + " write error\n");  //
                  System.exit(1);
                }

                ///////////////////////////////
                System.out.println(" finish");

}// i2bin




public void i2bin(String filename, int X, int Y,int[][] int_num)
{

        int I,J,K,L,M,N;
        int ix,iy;


         System.out.print(filename +"  Writing ...");
                //////// Binary writer ////////
		try {

			DataOutputStream dos = 
			       new DataOutputStream(new BufferedOutputStream(
                                     new FileOutputStream(filename), 20971520));


                        for(I=1;I<=Y;I++)
                        { 
                           for(J=1;J<=X;J++)
                           {

                                dos.writeShort(int_num[I][J]);

                           }// J
                        }// I


			dos.close();
		}
		catch(IOException e)
                {
                  System.err.println(filename + " write error\n");  //
                  System.exit(1);
                }

                ///////////////////////////////
                System.out.println(" finish");

}// i2bin




public void f2bin(String filename, int X, int Y, float[][] float_num)
{

        int I,J,K,L,M,N;
        int ix,iy;


                System.out.print(filename +"  Writing ...");
                //////// Binary writer ////////
		try {

			DataOutputStream dos = 
			       new DataOutputStream(new BufferedOutputStream(
                                     new FileOutputStream(filename), 20971520));


                        for(I=1;I<=Y;I++)
                        { 
                           for(J=1;J<=X;J++)
                           {

                                dos.writeFloat(float_num[I][J]);

                           }// J
                        }// I


			dos.close();
		}
		catch(IOException e)
                {
                  System.err.println(filename + " write error\n");  //
                  System.exit(1);
                }
                ///////////////////////////////
                System.out.println(" finish");

}// f2bin




public void d2bin(String filename, int X, int Y, double[][] double_num)
{

        int I,J,K,L,M,N;
        int ix,iy;


                System.out.print(filename +"  Writing ...");
                //////// Binary writer ////////
		try {

			DataOutputStream dos = 
			       new DataOutputStream(new BufferedOutputStream(
                                     new FileOutputStream(filename), 20971520));


                        for(I=1;I<=Y;I++)
                        { 
                           for(J=1;J<=X;J++)
                           {

                                dos.writeFloat( (float)(double_num[I][J]) );

                           }// J
                        }// I


			dos.close();
		}
		catch(IOException e)
                {
                  System.err.println(filename + " write error\n");  //
                  System.exit(1);
                }
                ///////////////////////////////
                System.out.println(" finish");

}// d2bin




public int[][] bin2i(String filename, int X, int Y)
{

        int I,J,K,L,M,N;
        int ix,iy;


        int int_num[][] = new int[Y+1][X+1];


                System.out.print(filename +"  Loading ...");
                //////// Binary reader ////////
		try {

			DataInputStream dis = 
			       new DataInputStream(new BufferedInputStream(
                                     new FileInputStream(filename), 20971520));


                        for(I=1;I<=Y;I++)
                        { 
                           for(J=1;J<=X;J++)
                           {

                                int_num[I][J] = dis.readShort();

                           }// J
                        }// I


			dis.close();
		}
		catch(IOException e)
                {
                  System.err.println(filename + " read error\n");  //
                  System.exit(1);
                }
                ///////////////////////////////
                System.out.println(" finish");


 return(int_num);

}// bin2i




public float[][] bin2f(String filename, int X, int Y)
{

        int I,J,K,L,M,N;
        int ix,iy;

        float float_num[][] = new float[Y+1][X+1];


                System.out.print(filename +"  Loading ...");
                //////// Binary reader ////////
		try {

			DataInputStream dis = 
			       new DataInputStream(new BufferedInputStream(
                                     new FileInputStream(filename), 20971520));


                        for(I=1;I<=Y;I++)
                        { 
                           for(J=1;J<=X;J++)
                           {

                                float_num[I][J] = dis.readFloat();

                           }// J
                        }// I


			dis.close();
		}
		catch(IOException e) 
                {
                  System.err.println(filename + " read error\n");  //
                  System.exit(1);
                }
                ///////////////////////////////
                System.out.println(" finish");


 return(float_num);

}// bin2f




public double[][] bin2d(String filename, int X, int Y)
{

        int I,J,K,L,M,N;
        int ix,iy;

        double double_num[][] = new double[Y+1][X+1];


                System.out.print(filename +"  Loading ...");
                //////// Binary reader ////////
		try {

			DataInputStream dis = 
			       new DataInputStream(new BufferedInputStream(
                                     new FileInputStream(filename), 20971520));


                        for(I=1;I<=Y;I++)
                        { 
                           for(J=1;J<=X;J++)
                           {

                                double_num[I][J] = (double)(dis.readFloat());

                           }// J
                        }// I


			dis.close();
		}
		catch(IOException e) 
                {
                  System.err.println(filename + " read error\n");  //
                  System.exit(1);
                }
                ///////////////////////////////
                System.out.println(" finish");

 return(double_num);

}// bin2d




public int[][] bin2iu(String filename, int X, int Y)
{

        int I,J,K,L,M,N;
        int ix,iy;


        int int_num[][] = new int[Y+1][X+1];


                System.out.print(filename +"  Loading ...");
                //////// Binary reader ////////
		try {

			DataInputStream dis = 
			       new DataInputStream(new BufferedInputStream(
                                     new FileInputStream(filename), 20971520));


                        for(I=1;I<=Y;I++)
                        { 
                           for(J=1;J<=X;J++)
                           {

                                int_num[I][J] = dis.readUnsignedShort();

                           }// J
                        }// I


			dis.close();
		}
		catch(IOException e)
                {
                  System.err.println(filename + " read error\n");  //
                  System.exit(1);
                }
                ///////////////////////////////
                System.out.println(" finish");


 return(int_num);

}// bin2iu





}
